package sun.java2d.d3d;

import sun.java2d.pipe.BufferedContext;
import sun.java2d.InvalidPipeException;
import java.awt.Composite;
import sun.java2d.SunGraphics2D;
import sun.java2d.loops.GraphicsPrimitiveMgr;
import sun.java2d.loops.CompositeType;
import sun.java2d.loops.SurfaceType;
import sun.java2d.loops.GraphicsPrimitive;
import sun.java2d.pipe.BufferedMaskFill;

class D3DMaskFill extends BufferedMaskFill
{
    static void register() {
        GraphicsPrimitiveMgr.register(new GraphicsPrimitive[] { new D3DMaskFill(SurfaceType.AnyColor, CompositeType.SrcOver), new D3DMaskFill(SurfaceType.OpaqueColor, CompositeType.SrcNoEa), new D3DMaskFill(SurfaceType.GradientPaint, CompositeType.SrcOver), new D3DMaskFill(SurfaceType.OpaqueGradientPaint, CompositeType.SrcNoEa), new D3DMaskFill(SurfaceType.LinearGradientPaint, CompositeType.SrcOver), new D3DMaskFill(SurfaceType.OpaqueLinearGradientPaint, CompositeType.SrcNoEa), new D3DMaskFill(SurfaceType.RadialGradientPaint, CompositeType.SrcOver), new D3DMaskFill(SurfaceType.OpaqueRadialGradientPaint, CompositeType.SrcNoEa), new D3DMaskFill(SurfaceType.TexturePaint, CompositeType.SrcOver), new D3DMaskFill(SurfaceType.OpaqueTexturePaint, CompositeType.SrcNoEa) });
    }
    
    protected D3DMaskFill(SurfaceType srcType, CompositeType compType) {
        super(D3DRenderQueue.getInstance(), srcType, compType, D3DSurfaceData.D3DSurface);
    }
    
    @Override
    protected native void maskFill(int p0, int p1, int p2, int p3, int p4, int p5, int p6, byte[] p7);
    
    @Override
    protected void validateContext(SunGraphics2D sg2d, Composite comp, int flags) {
        D3DSurfaceData d3DSurfaceData;
        try {
            d3DSurfaceData = (D3DSurfaceData)sg2d.surfaceData;
        }
        catch (ClassCastException ex) {
            throw new InvalidPipeException("wrong surface data type: " + sg2d.surfaceData);
        }
        BufferedContext.validateContext(d3DSurfaceData, d3DSurfaceData, sg2d.getCompClip(), comp, null, sg2d.paint, sg2d, flags);
    }
}
